Subject: Re: [PATCH net-next] pds_core: remove redundant pci_clear_master()

From: Leon Romanovsky <[email-masked]>
Date: Wed, 16 Aug 2023 13:39:41 +0300

On Wed, Aug 16, 2023 at 05:39:33PM +0800, Yu Liao wrote:
> On 2023/8/16 14:38, Leon Romanovsky wrote:
> > On Wed, Aug 16, 2023 at 09:38:02AM +0800, Yu Liao wrote:
> >> pci_disable_device() involves disabling PCI bus-mastering. So remove
> >> redundant pci_clear_master().
> > 
> > I would say that this commit message needs to be more descriptive and
> > explain why pci_disable_device() will actually disable PCI in these
> > flows.
> > 
> > According to the doc and code:
> >   2263  * Note we don't actually disable the device until all callers of 
> >   2264  * pci_enable_device() have called pci_disable_device().
> > 
> > Thanks
> > 
> Thank you for the review. My bad, I didn't describe it clearly in commit
> message. I will send the v2 version and add the following explanation:
> 
> do_pci_disable_device() disable PCI bus-mastering as following:
> static void do_pci_disable_device(struct pci_dev *dev)
> {
> 		u16 pci_command;
> 
> 		pci_read_config_word(dev, PCI_COMMAND, &pci_command);
> 		if (pci_command & PCI_COMMAND_MASTER) {
> 				pci_command &= ~PCI_COMMAND_MASTER;
> 				pci_write_config_word(dev, PCI_COMMAND, pci_command);
> 		}
> 
> 		pcibios_disable_device(dev);
> }
> And pci_disable_device() sets dev->is_busmaster to 0.
> 
> So for pci_dev that has called pci_enable_device(), pci_disable_device()
> involves disabling PCI bus-mastering. Remove redundant pci_clear_master() in
> the following places:
> - In error path 'err_out_clear_master' of pdsc_probe(), pci_enable_device()
> has already been called.
> - In pdsc_remove(), pci_enable_device() has already been called in pdsc_probe().

All that you need to add is a sentence that pci_enable_device() is
called only once before calling to pci_disable_device() and such
pci_clear_master() is not needed.

Thanks